<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Will you bury the residues of this crop ?</translate>
            </div>
            <q-btn-toggle
              v-model="storeResiduesAreBuried"
              :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
              toggle-color="primary"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
              <CancelButton v-if="isCancelable" />
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import CancelButton from 'src/pages/fieldbook/fertilization/algorithms/visione/pages/non-tree-crop-pages/rotation/components/CancelButton'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VisioneMixins from 'src/pages/fieldbook/fertilization/algorithms/visione/mixins/VisioneMixins'
import RotationMixin from 'src/pages/fieldbook/fertilization/algorithms/visione/pages/non-tree-crop-pages/rotation/mixins/RotationMixin'

export default {
  name: 'VisioneAddCropRotationResiduesPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    CancelButton
  },
  mixins: [PlatformMixin, AlgorithmsMixins, VisioneMixins, RotationMixin],
  data () {
    return {
    }
  },
  computed: {
    canContinue () {
      return this.storeResiduesAreBuried != null
    },
    customInputRules () {
      return [
        val => !isNaN(val) || `${this.$gettext('Must be a number')}`,
        val => !!val || `* ${this.$gettext('This field is required')}`,
        val => val >= 0 || `${this.$gettext('Must be positive')}`
      ]
    },
    pageTitle () {
      return this.isCancelable
        ? this.$gettext('New Rotation - Residues')
        : this.$gettext('Residues')
    },
    pageSubTitle () {
      return 'Visione'
    },
    storeResiduesAreBuried: {
      get () {
        return this.$store.state.fertilizationPlan?.parameters?.new_rotation?.residues_are_buried
      },
      set (value) {
        this.updateNewRotationParameter('residues_are_buried', value)
      }
    }
  },
  apollo: {
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'visioneAddCropRotationFertilizations'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'visioneAddCropRotationCyclesAndYield'
      })
    }
  }
}
</script>
